#define ooNumberingTypeARABIC     4  && Numbering is in Arabic numbers as "1, 2, 3, 4, ..."
#define ooFontSlantNONE           0  && specifies a font without slant
#define ooFontSlantITALIC         2  && specifies an italic font (slant designed into the font)
#define ooFontWeightNORMAL        100.000000  && specifies a normal font weight.
#define ooFontWeightBOLD          150.000000  && specifies a 150% font weight.
#define ooParagraphAdjustLEFT     0  && adjusted to the left border
#define ooParagraphAdjustBLOCK    2  && adjusted to both borders / stretched, except for last line
#define ooParagraphAdjustCENTER   3  && adjusted to the center
#define ooParagraphAdjustSTRETCH  4  && adjusted to both borders / stretched, including last line
#define ooTextContentAnchorTypeAS_CHARACTER 1  && The object is anchored instead of a character
*--   
#define vbHourglass 11
#define vbDefault 0

PROCEDURE VfpWriterExample()
LOCAL oDesktop, cURL, aFileProperties[2], oDoc, oSheet, lcOOoVesion, oView, laArgs[1]

*--  
If AT("LibOOo", SET("PROCEDURE")) = 0  
	SET PROCEDURE TO LibOOo ADDITIVE  
EndIf 

*--    OpenOffice.org  
If OOoIsInstalled()
	WAIT WINDOW NOWAIT " OpenOffice.org Calc. ..."
Else
	=MessageBox(' OpenOffice.org     !',48,'  ')
	Return .F.
EndIf

*--     " "
_SCREEN.MousePointer = vbHourglass

*--    Writer
oDesktop = OOoGetDesktop()
cURL = "private:factory/swriter"
aFileProperties[1] = OOoPropertyValue( "Hidden", .T. )
aFileProperties[2] = OOoPropertyValue( "ReadOnly", .F. )
oDoc = oDesktop.LoadComponentFromUrl( cURL, "_blank", 0, @ aFileProperties )
COMARRAY( oDoc, 10 )

*--     "ArabicNumbering1"   
*--       Writer     "Module1"
sBasicModuleName = "Module1"  

*--     StarBasic   sBasicModule
*--    ,  VFP  .
*--         VFP
*--   (      !)
*--   OpenOffice VFP    ,
*--      ,   ,  
*--         VFP  
*-- ,       
*--  Automation Bridge!
*--        .
TEXT TO sBasicModule NOSHOW
REM  *****  BASIC  *****
REM  (c) 24.07.2007 Roman V.Koltsov, Tambov, Russia
REM  mailto: rvc44@rambler.ru, ICQ: 44612299,
REM  phones: +7 (905) 1223500, +7 (910) 7541000
	
Sub Main
	Dim oDoc, oFamilies, oNumStyles, sStyleName, iNumberingType, oStyle
	'    
	oDoc = ThisComponent
	'     
	oFamilies = oDoc.getStyleFamilies()
	'      
	oNumStyles = oFamilies.getByName("NumberingStyles")
	'   
	sStyleName = "ArabicNumbering1"
	'      
	iNumberingType = com.sun.star.style.NumberingType.ARABIC
	'    NumberingType  ParentNumbering
	oStyle = oNumStyles.getByName(sStylename)
	oNumRules = oStyle.NumberingRules
	For j = 0 to oNumRules.GetCount() - 1
		mLevel = oNumRules.getByIndex(j)
		For i = LBound(mLevel) To UBound(mLevel)
			vProperty = mLevel(i)
			If (vProperty.Name = "NumberingType") Then
				vProperty.Value = iNumberingType
			End If
			If (vProperty.Name = "ParentNumbering") Then
				vProperty.Value = 3
			End If
			mLevel(i) = vProperty
		Next i
		oNumRules.replaceByIndex(j, mLevel)
	Next j
	oStyle.NumberingRules = oNumRules
End Sub
ENDTEXT

*--      ()    Writer
oLibrary = oDoc.BasicLibraries.GetByName("Standard") 
oLibrary.InsertByName(sBasicModuleName, sBasicModule)	

*-- Get the document's current controller.    .
oView = oDoc.getCurrentController()

*-- Get the document's frame
oFrame = oView.getFrame()

*--   Writer'      
oWindow = oFrame.getContainerWindow()
oWindow.SetVisible(.F.)

oText = oDoc.getText()
oCursor = oText.createTextCursor()

*--     
oDocInfo = oDoc.getDocumentInfo()

*--     
oDocDate = oDocInfo.CreationDate

*--        
sDate = PadL(AllT(Str(oDocDate.Day)),2,'0')+'.'+PadL(AllT(Str(oDocDate.Month)),2,'0')+'.'+PadL(AllT(Str(oDocDate.Year)),4,'0')  && DateSerial(oDocDate.Year, oDocDate.Month, oDocDate.Day)
sTime = PadL(AllT(Str(oDocDate.Hours)),2,'0')+':'+PadL(AllT(Str(oDocDate.Minutes)),2,'0')+':'+PadL(AllT(Str(oDocDate.Seconds)),2,'0')  && TimeSerial(oDocDate.Hours, oDocDate.Minutes, oDocDate.Seconds)

*--      
oFamilies = oDoc.getStyleFamilies()

*--   ,    
sPageStyleName = oCursor.PageStyleName
oPageStyles = oFamilies.getByName("PageStyles")
oStyle = oPageStyles.getByName(sPageStyleName)
oStyle.LeftMargin = 3000
oStyle.TopMargin = 2000
oStyle.RightMargin = 1500
oStyle.BottomMargin = 2000

*--       
oNumStyles = oFamilies.getByName("NumberingStyles")

*--     
sStyleName = "ArabicNumbering1"  &&    , , "Numbering 5".    !

*--       
*--  VFP   : oNumRules.replaceByIndex(lJ-1, @ mLevel)
*--   mLevel   list-of-list.  !!!
iNumberingType = ooNumberingTypeARABIC  && com.sun.star.style.NumberingType.ARABIC

*--       ,   " "
If !oNumStyles.HasByName(sStyleName)
	*--   " "
	oStyle = oDoc.createInstance("com.sun.star.style.NumberingStyle")
	*-- save style in order to set all properties
	oNumStyles.insertByName( sStyleName, oStyle )
	*-- ...  (     VFP)    StarBasic,     
************
*		*--       27.07.07  17:32 
*		*--     Automation Bridge! 
*		*--     .      ...
*		*-- reopen style in order to change the NumberingType 
*		oStyle = oNumStyles.getByName(sStylename) 
*		*-- iterate through the Numbering Rules 
*		oNumRules = oStyle.NumberingRules 
*		For lJ = 1 To oNumRules.GetCount()
*			*--  mLevel     oRule
*			oRule = oNumRules.getByIndex(lJ-1)   && 0..9
*			*-- search the property "NumberingType" in the Property-Set 
*			For lI = 1 To ALEN(oRule)  && For lI = LBound(oRule) To UBound(oRule)
*				*--  oProp     oProp
*				oProp = oRule[lI] 
*				*-- NumberingType specifies the type of numbering.
*				If (oProp.Name = "NumberingType")  && If oRule[lI].Name = "NumberingType"
*					*-- and give it the passed Format 
*					oProp.Value = iNumberingType   && oRule[lI].Value = ooNumberingTypeARABIC
*				EndIf 
*				*-- http://api.openoffice.org/docs/common/ref/com/sun/star/text/NumberingLevel.html
*				*-- ParentNumbering - number of upper levels that are included in the current numbering symbol
*				If (oProp.Name = "ParentNumbering")
*					*-- and give it the passed Format 
*					oProp.Value = 3
*				EndIf
*				oRule[lI] = oProp 
*			EndFor
*			*-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*			*--   OpenOffice  VFP    (!)   
*			*--    ,     StarBasic   !
*			*--    :
*			* oNumRules.replaceByIndex(lJ-1, oRule)
*		EndFor
*		*-- overwrite the old NumberingRules with the new ones
*		oStyle.NumberingRules = oNumRules
*************
EndIf

*--    ,     
oParaStyles = oFamilies.getByName( "ParagraphStyles" )
If !oParaStyles.HasByName( sStyleName )
	*-- create paragraph style here
	oStyle = oDoc.createInstance("com.sun.star.style.ParagraphStyle")
	oStyle.ParentStyle = "Standard"  && ""
	oStyle.FollowStyle = sStyleName
	oStyle.ParaOrphans = 3  && specifies the minimum number of lines of the paragraph that have to be at bottom of a page if the paragraph is spread over more than one page.
	oStyle.ParaWidows = 3   && specifies the minimum number of lines of the paragraph that have to be at top of a page if the paragraph is spread over more than one page. 
	oStyle.ParaTopMargin = 200  && determines the top margin of the paragraph in 100th mm.
	oStyle.ParaBottomMargin = 200  && determines the bottom margin of the paragraph in 100th mm.
	oStyle.ParaLeftMargin = 200  && determines the left margin of the paragraph in 100th mm.
	oStyle.ParaAdjust = ooParagraphAdjustBLOCK  && com.sun.star.style.ParagraphAdjust.BLOCK
	oStyle.NumberingStyleName = sStyleName
	oParaStyles.insertByName( sStyleName, oStyle )
EndIf

*--   ,   
oTextRange = oText.getEnd()  && oText.getStart()
*--     ,       ():
oTextRange.ParaStyleName = "Standard"  && "";   :  "Heading 4" <=> " 4" ; "Numbering 1"  <=> " 1"
oTextRange.ParaAdjust = ooParagraphAdjustCENTER  && com.sun.star.style.ParagraphAdjust.CENTER

*--   
sFileName = [Gerb.bmp]
sConvFileName = [C:\] + sFileName
cURL = "file:///" + CHRTRAN( sConvFileName, "\", "/" )  && OOoConvertToURL( sConvFileName )

*--  2      OPENOFFICE WRITER

*-- 1.    -    .     !
*	If File(sConvFileName)
*		oGraphicObject = oDoc.createInstance("com.sun.star.text.GraphicObject")  && oDoc.createInstance("com.sun.star.drawing.GraphicObjectShape")
*		With oGraphicObject
*			.GraphicURL = cURL
*			.AnchorType = ooTextContentAnchorTypeAS_CHARACTER  && com.sun.star.text.TextContentAnchorType.AS_CHARACTER
*		EndWith
*		oText.insertTextContent(oCursor, oGraphicObject, .F.)
*	EndIf
*	oText.insertString(oCursor, Chr(13), .F.)

*-- 2.       .      !
If File(sConvFileName)
	oGraphicObject = oDoc.createInstance("com.sun.star.drawing.GraphicObjectShape")
	*-- Set URL to the graphic.
	oGraphicObject.GraphicURL = cURL
	*-- Assuming a text document, add it to the single draw page.
	oDoc.getDrawpage().add(oGraphicObject)
EndIf

*--   
oSize = OOoCreateStruct( "com.sun.star.awt.Size" )
oSize.Width = 1770  &&   1/100 
oSize.Height = 2220  &&   1/100 
oGraphicObject.Size = oSize  && oGraphicObject.setSize(oSize)

*--   (  !)
*	oPosition = OOoCreateStruct( "com.sun.star.awt.Point" )
*	oPosition.X = 0
*	oPosition.Y = 0
*	oGraphicObject.Position = oPosition  && oGraphicObject.setPosition(oPosition)

oTextRange.CharFontName = "Times New Roman"
oTextRange.CharHeight = 14.00
oTextRange.CharPosture = ooFontSlantNONE  && com.sun.star.awt.FontSlant.NONE
oTextRange.CharWeight = ooFontWeightBOLD  && com.sun.star.awt.FontWeight.BOLD
*--    
oTextRange.CharColor = OOoRGB(0,0,0)      &&  : OOoRGB(0,0,255)
oTextRange.setString ( Chr(13)+Chr(13)+"    "+Chr(10)+" "+Chr(13) )
oTextRange = oText.getEnd()
oTextRange.CharHeight = 18.00
oTextRange.setString ( Chr(13)+"          "+Chr(13) )

oTextRange = oText.getEnd()
oTextRange.CharHeight = 12.00
oTextRange.CharWeight = ooFontWeightNORMAL      && com.sun.star.awt.FontWeight.NORMAL
oText.insertString(oCursor, Chr(13)+". "+Chr(13)+Chr(13)+Chr(13), .F.)
oTextRange = oText.getEnd()
oTextRange.ParaAdjust = ooParagraphAdjustBLOCK  && com.sun.star.style.ParagraphAdjust.BLOCK
oText.insertString(oCursor, "        "+Chr(10), .F.)
oText.insertString(oCursor, "     "+Chr(10), .F.)
oText.insertString(oCursor, ",    "+Chr(10), .F.)
oText.insertString(oCursor, " "+Chr(13)+Chr(13), .F.)

oText.insertString(oCursor, Chr(9)+"      19.02.2007"+Chr(10), .F.)
oText.insertString(oCursor, " 162        "+Chr(10), .F.)
oText.insertString(oCursor, "        "+Chr(10), .F.)
oText.insertString(oCursor, "  ,  "+Chr(10), .F.)
oText.insertString(oCursor, "   ,  "+Chr(10), .F.)
oText.insertString(oCursor, "            :"+Chr(13), .F.)

*-- Restart the numbering
oCursor.NumberingStartValue = 1  && specifies the start value for numbering if a new numbering starts at this paragraph

*--    sStyleName
oTextRange = oText.getEnd()
oTextRange.ParaStyleName = sStyleName
oTextRange.ParaAdjust = ooParagraphAdjustBLOCK  && com.sun.star.style.ParagraphAdjust.BLOCK
oTextRange.CharFontName = "Times New Roman"  && ,    Prof: Arial
oTextRange.CharHeight = 12.00
oTextRange.CharPosture = ooFontSlantNONE   && com.sun.star.awt.FontSlant.NONE
oTextRange.CharWeight = ooFontWeightNORMAL && com.sun.star.awt.FontWeight.BOLD

oCursor.NumberingLevel = 0  && specifies the numbering level of the paragraph
oText.insertString(oCursor, "      "+Chr(10), .F.)
oText.insertString(oCursor, "   ,  "+Chr(10), .F.)
oText.insertString(oCursor, "    :"+Chr(13), .F.)

	******************************************************
	*--       
	oCursor.NumberingLevel = 1
	oText.insertString(oCursor, " "+Chr(13), .F.)

	oCursor.NumberingLevel = 2
	m.lcReceiver = "   (1000001)"
	m.lcReceiver = m.lcReceiver + "   " + "01.01.2003" + "  ,  "
	m.lcReceiver = m.lcReceiver + "   "
	m.lcReceiver = m.lcReceiver + ",  "+"01.09.2007"+ ;
				   "   " + "70" + "%     "+ ;
				   "      ;"
	oText.insertString(oCursor, m.lcReceiver+Chr(13), .F.)

	oCursor.NumberingLevel = 1
	oText.insertString(oCursor, " "+Chr(13), .F.)

	oCursor.NumberingLevel = 2
	m.lcReceiver = "   (2000001)"
	m.lcReceiver = m.lcReceiver + "   " + "01.06.2004" + "  ,  "
	m.lcReceiver = m.lcReceiver + "   "
	m.lcReceiver = m.lcReceiver + ",  "+"01.06.2007"+ ;
				   "   " + "50" + "%     "+ ;
				   "      ;"
	oText.insertString(oCursor, m.lcReceiver+Chr(13), .F.)
	******************************************************

oCursor.NumberingLevel = 0
oText.insertString(oCursor, "       ."+Chr(13), .F.)
*--    "Standard" ("")
oTextRange = oText.getEnd()
oTextRange.ParaStyleName = "Standard"  && ""
oTextRange.ParaAdjust = ooParagraphAdjustLEFT  && com.sun.star.style.ParagraphAdjust.LEFT
oTextRange.CharFontName = "Times New Roman"  && ,    Prof: Arial
oTextRange.CharHeight = 12.00
oText.insertString(oCursor, Chr(13)+Chr(13)+"   "+Chr(10), .F.)
oText.insertString(oCursor, "  "+Replicate(Chr(9),7)+", .."+Chr(13)+Chr(13), .F.)
oTextRange = oText.getEnd()
oTextRange.CharHeight = 8.00
oText.insertString(oCursor, "  : "+sDate+" ."+Chr(13), .F.)  &&   
oText.insertString(oCursor, "  : "+sTime+Chr(13), .F.)     &&   
oText.insertString(oCursor, ": "+oDocInfo.Author+Chr(13), .F.)  &&   (    !)
* oText.insertString(oCursor, Chr(13), .F.)

DO pcdone

*--     Microsoft Word.    OpenOffice    ,   MS!!!
*--   ,        .    !
sFileName = [Order.doc]
sConvFileName = [C:\] + sFileName
cURL = "file:///" + CHRTRAN( sConvFileName, "\", "/" )  && OOoConvertToURL( sConvFileName )
laArgs[1] = OOoPropertyValue("FilterName", "MS Word 97")
oDoc.storeAsURL(cURL, @laArgs)

*--    
oWindow.SetVisible(.T.)

*--    ,     
lsWinTitle = oFrame.getPropertyValue("Title")

*--   Writer   .      Windows 98!
TRY
	loShell = CreateObject("WScript.Shell")
	loShell.AppActivate(lsWinTitle)
	loShell.SendKeys("")  && . http://forum.foxclub.ru/read.php?29,252421,252421#msg-252421
CATCH
ENDTRY

_SCREEN.MousePointer = vbDefault

*--       
*--      "javascript". ,  VFP  ...  -  !
*--  ,    : The VARIANT does not contain an object type!..
LOCAL sMacroURL, oScr, oVarArray
oScr = CreateObject("MSScriptControl.ScriptControl")
oScr.Language = "javascript"
oScr.Eval("Arr = new Array()")
oVarArray = oScr.Eval("Arr")

*--   Main   Module1  Standard  ,    Order
sMacroURL = "macro://Order/Standard.Module1.Main"  &&  "macro://./Standard.Module1.Main"  && MacroExecutionMode = com.sun.star.document.MacroExecMode.ALWAYS_EXECUTE_NO_WARN
oDispatcher = OOoServiceManager_CreateInstance("com.sun.star.frame.DispatchHelper")
oDispatcher.executeDispatch(oDesktop, sMacroURL, "", 0, oVarArray)  &&  OOoRunMacro!!!

*--     
oViewCursor = oView.getViewCursor()
oViewCursor.jumpToFirstPage()
oViewCursor.jumpToStartOfPage()
*--   10  
oViewCursor.goDown( 10, .F. )
*--    
oViewCursor.gotoStartOfLine( .F. )

*	*--     
*	oViewCursor = oView.getViewCursor()
*	oViewCursor.jumpToLastPage()
*	oViewCursor.jumpToEndOfPage()

*--   ,  ,      
If (oDoc.hasLocation() And (Not oDoc.isReadOnly()))
	oDoc.store()
EndIf

*  Public-     RPC   
RELEASE goOOoDesktop, goOOoConfigProvider

WAIT CLEAR
